﻿using System;
using System.Linq;

namespace UnprotectedData
{
    // http://www.dotnetperls.com/asparallel
    class Program
    {
        static int _counter;
        static bool IsEvenCounter(int value)
        {
            // ... Return whether counter field is even.
            bool even = _counter % 2 == 0;
            _counter++;
            return even;
            //return _counter++ % 2 == 0;
        }

        static void Main()
        {
            //Func<int, bool> func = IsEvenCounter;
            int[] array = Enumerable.Range(0, 1000).ToArray();

            // ... Use parallel query ten times on the array.
            // ... Write number of results matched by Func.
            for (int i = 0; i < 10; i++)
            {
                var result = array.AsParallel().Where(IsEvenCounter);
                Console.WriteLine(result.Count());
            }
        }
    }
}
